#ifndef __ABAC_PL_YY_H__
#define __ABAC_PL_YY_H__

/* C declarations */
#include "abac_pl.h"
#include "abac_list.h"
#include "abac_util.h"
#include "abac_rt.h"

typedef struct _abac_yy_principal_t abac_yy_principal_t;
typedef struct _abac_yy_param_principal_t abac_yy_param_principal_t;
typedef struct _abac_yy_param_data_t abac_yy_param_data_t;
typedef struct _abac_yy_dterm_t abac_yy_dterm_t;
typedef struct _abac_yy_role_t abac_yy_role_t;
typedef struct _abac_yy_role_expression_t abac_yy_role_expression_t;

enum expr_rtype {
    EXPR_NAMED=1,
    EXPR_ROLE=2,
    EXPR_LINKED=3
};

enum dterm_type {
    DTERM_PRINCIPAL=1,
    DTERM_NAMED=2,
    DTERM_DATA=3,
    DTERM_ANONYMOUS=4
};

#endif /* __ABC_PL_YY_H__ */
